import pytest

from days.day_11 import get_neighbours, go_to_step, first_synchronised_flash

octopuses = {
    (0, 0): 5, (1, 0): 4, (2, 0): 8, (3, 0): 3, (4, 0): 1, (5, 0): 4, (6, 0): 3, (7, 0): 2, (8, 0): 2, (9, 0): 3,
    (0, 1): 2, (1, 1): 7, (2, 1): 4, (3, 1): 5, (4, 1): 8, (5, 1): 5, (6, 1): 4, (7, 1): 7, (8, 1): 1, (9, 1): 1,
    (0, 2): 5, (1, 2): 2, (2, 2): 6, (3, 2): 4, (4, 2): 5, (5, 2): 5, (6, 2): 6, (7, 2): 1, (8, 2): 7, (9, 2): 3,
    (0, 3): 6, (1, 3): 1, (2, 3): 4, (3, 3): 1, (4, 3): 3, (5, 3): 3, (6, 3): 6, (7, 3): 1, (8, 3): 4, (9, 3): 6,
    (0, 4): 6, (1, 4): 3, (2, 4): 5, (3, 4): 7, (4, 4): 3, (5, 4): 8, (6, 4): 5, (7, 4): 4, (8, 4): 7, (9, 4): 8,
    (0, 5): 4, (1, 5): 1, (2, 5): 6, (3, 5): 7, (4, 5): 5, (5, 5): 2, (6, 5): 4, (7, 5): 6, (8, 5): 4, (9, 5): 5,
    (0, 6): 2, (1, 6): 1, (2, 6): 7, (3, 6): 6, (4, 6): 8, (5, 6): 4, (6, 6): 1, (7, 6): 7, (8, 6): 2, (9, 6): 1,
    (0, 7): 6, (1, 7): 8, (2, 7): 8, (3, 7): 2, (4, 7): 8, (5, 7): 8, (6, 7): 1, (7, 7): 1, (8, 7): 3, (9, 7): 4,
    (0, 8): 4, (1, 8): 8, (2, 8): 4, (3, 8): 6, (4, 8): 8, (5, 8): 4, (6, 8): 8, (7, 8): 5, (8, 8): 5, (9, 8): 4,
    (0, 9): 5, (1, 9): 2, (2, 9): 8, (3, 9): 3, (4, 9): 7, (5, 9): 5, (6, 9): 1, (7, 9): 5, (8, 9): 2, (9, 9): 6
}


@pytest.mark.parametrize('coord, expected', [
    ((0, 0), [(1, 0), (0, 1), (1, 1)]),
    ((3, 0), [(2, 0), (2, 1), (3, 1), (4, 1), (4, 0)]),
    ((9, 0), [(8, 0), (8, 1), (9, 1)]),
    ((0, 4), [(0, 3), (1, 3), (1, 4), (1, 5), (0, 5)]),
    ((9, 4), [(9, 3), (8, 3), (8, 4), (8, 5), (9, 5)]),
    ((0, 9), [(0, 8), (1, 8), (1, 9)]),
    ((6, 9), [(5, 9), (5, 8), (6, 8), (7, 8), (7, 9)]),
    ((9, 9), [(9, 8), (8, 8), (8, 9)]),
    ((6, 7), [(5, 6), (5, 7), (5, 8), (6, 8), (7, 8), (7, 7), (7, 6), (6, 6)]),
])
def test_get_neighbours(coord, expected):
    actual = get_neighbours(coord)

    assert sorted(actual) == sorted(expected)


@pytest.mark.parametrize('steps, expected', [
    (1, 0),
    (2, 35),
    (10, 204),
    (100, 1656)
])
def test_count_flashed(steps, expected):
    _, actual = go_to_step(octopuses, steps)

    assert actual == expected


def test_first_synchronised_flash():
    expected = 195

    actual = first_synchronised_flash(octopuses)

    assert actual == expected